%global _hardened_build 1
# exclude devel(libocsync)
%define _requires_exceptions devel(libocsync(64bit))\\|devel(libqt5keychain(64bit))

%define _cmake_skip_rpath %nil
%define libocsync_major 0
%define liblibocsync %mklibname ocsync %libocsync_major
%define nextcloudsync_major 0
%define libnextcloudsync %mklibname nextcloudsync %nextcloudsync_major
%define develname %mklibname %{name} -d

Name:           nextcloud-client
Version:        2.3.2
Release:        %mkrel 1
Summary:        The Nextcloud Client
Group:          Networking/File transfer
License:        LGPLv2+ and GPLv2
Url:            https://nextcloud.com/install/#install-clients
Source0:        https://github.com/nextcloud/client_theming/archive/v%{version}.tar.xz
Source1:        https://download.owncloud.com/desktop/stable/owncloudclient-%{version}.tar.xz
Source2:        %{name}.appdata.xml
Patch0:         %{name}-2.2.3-syslibs.patch
#--------------------------------------------------
BuildRequires:  cmake
BuildRequires:  desktop-file-utils
BuildRequires:  doxygen
BuildRequires:  lib64neon-devel
BuildRequires:  lib64openssl-devel
BuildRequires:  python-sphinx
BuildRequires:  appstream-util

BuildRequires: kf5-macros
BuildRequires: lib64kcoreaddons-devel
BuildRequires: lib64kio-devel
BuildRequires: lib64openssl-devel
BuildRequires: lib64qt5concurrent-devel
BuildRequires: lib64qt5core-devel
BuildRequires: lib64qt5dbus-devel
BuildRequires: lib64qt5gui-devel
BuildRequires: lib64qt5keychain-devel
BuildRequires: lib64qt5network-devel
BuildRequires: lib64qt5webkit-devel
BuildRequires: lib64qt5webkitwidgets-devel
BuildRequires: lib64qt5widgets-devel
BuildRequires: lib64qt5xml-devel
BuildRequires: lib64qtsingleapplication-qt5-devel
BuildRequires: lib64sqlite3-devel
BuildRequires: mesa-devel
BuildRequires: qtbase5-common-devel
BuildRequires: qttools5
BuildRequires: zlib1-devel
#--------------------------------------------------
Provides:       owncloud-client = %version-%release
Obsoletes:      owncloud-client

%description
Nextcloud-client enables you to connect to your private Nextcloud Server.
With it you can create folders in your home directory, and keep the contents
of those folders synced with your Nextcloud server. Simply copy a file into
the directory and the Nextcloud Client does the rest.

%files
%{_bindir}/nextcloud
%{_bindir}/nextcloudcmd
%{_datadir}/applications/nextcloud.desktop
%dir %{_datadir}/nextcloud
%{_datadir}/nextcloud/i18n/
%{_datadir}/icons/hicolor/*/apps/*
%{_datadir}/appdata/%{name}.appdata.xml
%dir %{_sysconfdir}/Nextcloud
%{_sysconfdir}/Nextcloud/sync-exclude.lst
#------------------------------------------------------------------------------
%{_libdir}/libnextcloudsync.so.%nextcloudsync_major
%{_libdir}/libnextcloudsync.so.%version
#------------------------------------------------------------------------------
%dir %_libdir/nextcloud
%_libdir/nextcloud/libocsync.so.%{libocsync_major}
%_libdir/nextcloud/libocsync.so.%{version}
#------------------------------------------------------------------------------

%package dolphin
Summary:        Dolphin overlay icons
Group:			Graphical desktop/KDE5
Requires:       dolphin
Requires:       %{name} = %{version}-%{release}

%description dolphin
The nextcloud desktop client dolphin extension for
KDE 5,

%files dolphin
%{_kf5_libdir}/libnextclouddolphinpluginhelper.so
%{_kf5_plugindir}/overlayicon/nextclouddolphinoverlayplugin.so
%{_qt5_plugindir}/nextclouddolphinactionplugin.so
%{_kf5_services}/nextclouddolphinactionplugin.desktop

#------------------------------------------------------------------------------

%package caja
Summary:        Mate Caja plugin
Group:			Graphical desktop/Mate
Requires:       mate-file-manager
Requires:       %{name} = %{version}-%{release}

%description caja
The nextcloud desktop client Caja extension for MATE.


%files caja
%{_datadir}/caja-python/extensions/syncstate-Nextcloud.py
#------------------------------------------------------------------------------

%package -n %{develname}
Summary:        Development files for nextcloud-client
Group:			Development/Libraries
License:        LGPLv2+
Provides:       %{name}-static = %{version}-%{release}
Provides:       %{name}-devel = %{version}-%{release}
Obsoletes:      %{name}-devel
# From owncloud-client
Obsoletes:      %{_lib}owncloud-client-devel

%description -n %{develname}
Development headers for use of the nextcloud-client library.

%files -n %{develname}
%{_libdir}/libnextcloudsync.so
%{_includedir}/nextcloudsync/
%{_libdir}/libnextcloudsync.so
%{_libdir}/nextcloud/libocsync.so

#------------------------------------------------------------------------------

%prep
%setup -q -n client_theming-%{version}
%setup -T -D -a 1 -n client_theming-%{version}
rm -Rf client
mv owncloudclient-%{version} client
#%patch0 -p1
#rm -rf src/3rdparty/qtlockedfile src/3rdparty/qtsingleapplication

# fix nextcloud desktop icon name (mga#19473#c6)
sed -i 's/^\(Icon\(\[.*\]\)*=\).*$/\1@APPLICATION_NAME@/' client/mirall.desktop.in

%build
#see https://www.openssl.org/docs/manmaster/crypto/OpenSSL_add_all_algorithms.html
#sed -i "s#SSLeay_add_all_algorithms#//OPENSSL_init_crypto#g" client/src/3rdparty/certificates/p12topem.cpp

%cmake_kf5 \
        -DCMAKE_SHARED_LINKER_FLAGS="-Wl,--as-needed" \
        -DOEM_THEME_DIR=`pwd`/../nextcloudtheme ../client
%make


%install
rm -rf %buildroot
%make_install -C build

%find_lang client
mkdir -p %{buildroot}%{_datadir}/appdata/
install -m 644 %{SOURCE2} %{buildroot}%{_datadir}/appdata/%{name}.appdata.xml

rm -rf %{buildroot}/%{_datadir}/nautilus-python/extensions
rm -rf %{buildroot}/%{_datadir}/nemo-python/extensions

%check
appstream-util validate-relax --nonet %{buildroot}%{_datadir}/appdata/%{name}.appdata.xml

desktop-file-install --vendor="" \
  --remove-category="Application" \
  --remove-category="X-SuSE-SyncUtility" \
  --add-category="X-MandrivaLinux-Internet-FileTransfer" \
  --dir $RPM_BUILD_ROOT%{_datadir}/applications $RPM_BUILD_ROOT%{_datadir}/applications/*.desktop


%changelog
* Fri Jul 21 2017 bb2 <bb2> 2.3.2-1pclos2017
- new version

* Sat Dec 17 2016 bb <bb> 2.2.4-2pclos2017
- fix req on devel package

* Tue Dec 13 2016 bb <bb> 2.2.4-1pclos2017
- import from france with lots of mods for pclos


